#include <stdio.h>
#include <dlfcn.h>

#include "magic_code.h"
#include "open_gui.h"

int open_gui(int argc, char **argv, bool is_debug) {
  void *lib_handle;
  void (*fn)(int*, int*);
  int (*gui)(int, char**);
  int a = 0;
  int b = 0;
  char *error;
  char *p;

  if(is_debug) p = "./libmelonvpngui.so";
  else p = "/usr/lib/melonvpn/libmelonvpngui.so";

  lib_handle = dlopen(p, RTLD_LAZY);
  if (!lib_handle) {
    fprintf(stderr, "Failed to open Melon VPN gui\n");
    fprintf(stderr, "Try installing the package 'melonvpngui'\n");
    fprintf(stderr, "%s\n", dlerror());
    return 1;
  }

  fn = dlsym(lib_handle, "get_magic_code");
  if ((error = dlerror()) != NULL) {
    fprintf(stderr, "Failed to open Melon VPN gui\n");
    fprintf(stderr, "The function 'get_magic_code' couldn't be found\n");
    fprintf(stderr, "Check the package 'melonvpngui' is installed correctly\n");
    fprintf(stderr, "%s\n", error);
    return 1;
  }

  (*fn)(&a,&b);

  if(a==MAGIC_CODE_A && b==MAGIC_CODE_B) {
    gui = dlsym(lib_handle, "run_gui");
    if((error = dlerror()) != NULL) {
      fprintf(stderr, "Failed to open Melon VPN gui\n");
      fprintf(stderr, "The function 'run_gui' couldn't be found\n");
      fprintf(stderr, "Check the package 'melonvpngui' is installed correctly\n");
      fprintf(stderr, "%s\n", error);
      return 1;
    }

    int fake_argc = 1;
    char *fake_argv[1] = {0};
    fake_argv[0] = argv[0];

    (*gui)(fake_argc,fake_argv);
  }

  dlclose(lib_handle);
  return 0;
}
